diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-rate-ops.cc ns-3.31/src/internet/model/tcp-rate-ops.cc
--- ns-3.30.1/src/internet/model/tcp-rate-ops.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/internet/model/tcp-rate-ops.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,292 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+#include "tcp-rate-ops.h"
+#include "ns3/log.h"
+#include "ns3/simulator.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("TcpRateOps");
+NS_OBJECT_ENSURE_REGISTERED (TcpRateOps);
+
+TypeId
+TcpRateOps::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::TcpRateOps")
+    .SetParent<Object> ()
+    .SetGroupName ("Internet")
+  ;
+  return tid;
+}
+
+NS_OBJECT_ENSURE_REGISTERED (TcpRateLinux);
+
+TypeId
+TcpRateLinux::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::TcpRateLinux")
+    .SetParent<TcpRateOps> ()
+    .SetGroupName ("Internet")
+    .AddTraceSource ("TcpRateUpdated",
+                     "Tcp rate information has been updated",
+                     MakeTraceSourceAccessor (&TcpRateLinux::m_rateTrace),
+                     "ns3::TcpRateLinux::TcpRateUpdated")
+    .AddTraceSource ("TcpRateSampleUpdated",
+                     "Tcp rate sample has been updated",
+                     MakeTraceSourceAccessor (&TcpRateLinux::m_rateSampleTrace),
+                     "ns3::TcpRateLinux::TcpRateSampleUpdated")
+  ;
+  return tid;
+}
+
+const TcpRateOps::TcpRateSample &
+TcpRateLinux::GenerateSample (uint32_t delivered, uint32_t lost, bool is_sack_reneg,
+                              uint32_t priorInFlight, const Time &minRtt)
+{
+  NS_LOG_FUNCTION (this << delivered << lost << is_sack_reneg);
+
+  /* Clear app limited if bubble is acked and gone. */
+  if (m_rate.m_appLimited != 0 && m_rate.m_delivered > m_rate.m_appLimited)
+    {
+      NS_LOG_INFO ("Updating Rate m_appLimited to zero");
+      m_rate.m_appLimited = 0;
+    }
+
+  NS_LOG_INFO ("Updating RateSample m_ackedSacked=" << delivered <<
+               ", m_bytesLoss=" << lost << " and m_priorInFlight" << priorInFlight);
+  m_rateSample.m_ackedSacked = delivered;   /* freshly ACKed or SACKed */
+  m_rateSample.m_bytesLoss   = lost;        /* freshly marked lost */
+  m_rateSample.m_priorInFlight = priorInFlight;
+
+  /* Return an invalid sample if no timing information is available or
+   * in recovery from loss with SACK reneging. Rate samples taken during
+   * a SACK reneging event may overestimate bw by including packets that
+   * were SACKed before the reneg.
+   */
+  if (m_rateSample.m_priorTime == Seconds (0) || is_sack_reneg)
+    {
+      NS_LOG_INFO ("PriorTime is zero, invalidating sample");
+      m_rateSample.m_delivered = -1;
+      m_rateSample.m_interval = Seconds (0);
+      m_rateSampleTrace (m_rateSample);
+      return m_rateSample;
+    }
+
+  // LINUX:
+  //  /* Model sending data and receiving ACKs as separate pipeline phases
+  //   * for a window. Usually the ACK phase is longer, but with ACK
+  //   * compression the send phase can be longer. To be safe we use the
+  //   * longer phase.
+  //   */
+  //  auto snd_us = m_rateSample.m_interval;  /* send phase */
+  //  auto ack_us = Simulator::Now () - m_rateSample.m_prior_mstamp;
+  //  m_rateSample.m_interval = std::max (snd_us, ack_us);
+
+  m_rateSample.m_interval = std::max (m_rateSample.m_sendElapsed, m_rateSample.m_ackElapsed);
+  m_rateSample.m_delivered = m_rate.m_delivered - m_rateSample.m_priorDelivered;
+  NS_LOG_INFO ("Updating sample interval=" << m_rateSample.m_interval << " and delivered data" << m_rateSample.m_delivered);
+
+  /* Normally we expect m_interval >= minRtt.
+   * Note that rate may still be over-estimated when a spuriously
+   * retransmistted skb was first (s)acked because "interval_us"
+   * is under-estimated (up to an RTT). However continuously
+   * measuring the delivery rate during loss recovery is crucial
+   * for connections suffer heavy or prolonged losses.
+   */
+  if (m_rateSample.m_interval < minRtt)
+    {
+      NS_LOG_INFO ("Sampling interval is invalid");
+      m_rateSample.m_interval  = Seconds (0);
+      m_rateSample.m_priorTime = Seconds (0); // To make rate sample invalid
+      m_rateSampleTrace (m_rateSample);
+      return m_rateSample;
+    }
+
+  /* Record the last non-app-limited or the highest app-limited bw */
+  if (!m_rateSample.m_isAppLimited
+      || (m_rateSample.m_delivered * m_rate.m_rateInterval >=
+          m_rate.m_rateDelivered * m_rateSample.m_interval))
+    {
+      m_rate.m_rateDelivered  = m_rateSample.m_delivered;
+      m_rate.m_rateInterval   = m_rateSample.m_interval;
+      m_rate.m_rateAppLimited = m_rateSample.m_isAppLimited;
+      m_rateSample.m_deliveryRate = DataRate (m_rateSample.m_delivered * 8.0 / m_rateSample.m_interval.GetSeconds ());
+      NS_LOG_INFO ("Updating delivery rate=" << m_rateSample.m_deliveryRate);
+    }
+
+  m_rateSampleTrace (m_rateSample);
+  return m_rateSample;
+}
+
+void
+TcpRateLinux::CalculateAppLimited (uint32_t cWnd, uint32_t in_flight,
+                                   uint32_t segmentSize, const SequenceNumber32 &tailSeq,
+                                   const SequenceNumber32 &nextTx, const uint32_t lostOut,
+                                   const uint32_t retransOut)
+{
+  NS_LOG_FUNCTION (this);
+
+  /* Missing checks from Linux:
+   * - Nothing in sending host's qdisc queues or NIC tx queue. NOT IMPLEMENTED
+   */
+  if (tailSeq - nextTx < static_cast<int32_t> (segmentSize)    // We have less than one packet to send.
+      && in_flight < cWnd                                      // We are not limited by CWND.
+      && lostOut <= retransOut)                                // All lost packets have been retransmitted.
+    {
+      m_rate.m_appLimited = std::max<uint32_t> (m_rate.m_delivered + in_flight, 1);
+      m_rateTrace (m_rate);
+    }
+
+  // m_appLimited will be reset once in GenerateSample, if it has to be.
+  // else
+  //  {
+  //    m_rate.m_appLimited = 0;
+  //  }
+}
+
+void
+TcpRateLinux::SkbDelivered (TcpTxItem * skb)
+{
+  NS_LOG_FUNCTION (this << skb);
+
+  TcpTxItem::RateInformation & skbInfo = skb->GetRateInformation ();
+
+  if (skbInfo.m_deliveredTime == Time::Max ())
+    {
+      return;
+    }
+
+  m_rate.m_delivered    += skb->GetSeqSize ();
+  m_rate.m_deliveredTime = Simulator::Now ();
+
+  if (m_rateSample.m_priorDelivered == 0
+      || skbInfo.m_delivered > m_rateSample.m_priorDelivered)
+    {
+      m_rateSample.m_priorDelivered   = skbInfo.m_delivered;
+      m_rateSample.m_priorTime        = skbInfo.m_deliveredTime;
+      m_rateSample.m_isAppLimited     = skbInfo.m_isAppLimited;
+      m_rateSample.m_sendElapsed      = skb->GetLastSent () - skbInfo.m_firstSent;
+      m_rateSample.m_ackElapsed       = Simulator::Now () - skbInfo.m_deliveredTime;
+
+      m_rateSampleTrace (m_rateSample);
+
+      m_rate.m_firstSentTime          = skb->GetLastSent ();
+    }
+
+  /* Mark off the skb delivered once it's taken into account to avoid being
+   * used again when it's cumulatively acked, in case it was SACKed.
+   */
+  skbInfo.m_deliveredTime = Time::Max ();
+  m_rate.m_txItemDelivered = skbInfo.m_delivered;
+  m_rateTrace (m_rate);
+}
+
+void
+TcpRateLinux::SkbSent (TcpTxItem *skb, bool isStartOfTransmission)
+{
+  NS_LOG_FUNCTION (this << skb << isStartOfTransmission);
+
+  TcpTxItem::RateInformation & skbInfo = skb->GetRateInformation ();
+
+  /* In general we need to start delivery rate samples from the
+   * time we received the most recent ACK, to ensure we include
+   * the full time the network needs to deliver all in-flight
+   * packets. If there are no packets in flight yet, then we
+   * know that any ACKs after now indicate that the network was
+   * able to deliver those packets completely in the sampling
+   * interval between now and the next ACK.
+   *
+   * Note that we use the entire window size instead of bytes_in_flight
+   * because the latter is a guess based on RTO and loss-marking
+   * heuristics. We don't want spurious RTOs or loss markings to cause
+   * a spuriously small time interval, causing a spuriously high
+   * bandwidth estimate.
+   */
+  if (isStartOfTransmission)
+    {
+      NS_LOG_INFO ("Starting of a transmission at time " << Simulator::Now ().GetSeconds ());
+      m_rate.m_firstSentTime = Simulator::Now ();
+      m_rate.m_deliveredTime = Simulator::Now ();
+      m_rateTrace (m_rate);
+    }
+
+  skbInfo.m_firstSent     = m_rate.m_firstSentTime;
+  skbInfo.m_deliveredTime = m_rate.m_deliveredTime;
+  skbInfo.m_isAppLimited  = (m_rate.m_appLimited != 0);
+  skbInfo.m_delivered     = m_rate.m_delivered;
+}
+
+std::ostream &
+operator<< (std::ostream & os, TcpRateLinux::TcpRateConnection const & rate)
+{
+  os << "m_delivered      = " << rate.m_delivered       << std::endl;
+  os << "m_deliveredTime  = " << rate.m_deliveredTime   << std::endl;
+  os << "m_firstSentTime  = " << rate.m_firstSentTime   << std::endl;
+  os << "m_appLimited     = " << rate.m_appLimited      << std::endl;
+  os << "m_rateDelivered  = " << rate.m_rateDelivered   << std::endl;
+  os << "m_rateInterval   = " << rate.m_rateInterval    << std::endl;
+  os << "m_rateAppLimited = " << rate.m_rateAppLimited  << std::endl;
+  os << "m_txItemDelivered = " << rate.m_txItemDelivered << std::endl;
+  return os;
+}
+
+std::ostream &
+operator<< (std::ostream & os, TcpRateLinux::TcpRateSample const & sample)
+{
+  os << "m_deliveryRate  = "  << sample.m_deliveryRate   << std::endl;
+  os << " m_isAppLimited = "  << sample.m_isAppLimited   << std::endl;
+  os << " m_interval     = "  << sample.m_interval       << std::endl;
+  os << " m_delivered    = "  << sample.m_delivered      << std::endl;
+  os << " m_priorDelivered = " << sample.m_priorDelivered << std::endl;
+  os << " m_priorTime    = "  << sample.m_priorTime      << std::endl;
+  os << " m_sendElapsed  = "  << sample.m_sendElapsed    << std::endl;
+  os << " m_ackElapsed   = "  << sample.m_ackElapsed     << std::endl;
+  os << " m_bytesLoss    = "  << sample.m_bytesLoss      << std::endl;
+  os << " m_priorInFlight= "  << sample.m_priorInFlight  << std::endl;
+  os << " m_ackedSacked  = "  << sample.m_ackedSacked    << std::endl;
+  return os;
+}
+
+bool
+operator== (TcpRateLinux::TcpRateSample const & lhs, TcpRateLinux::TcpRateSample const & rhs)
+{
+  return (lhs.m_deliveryRate   == rhs.m_deliveryRate
+          && lhs.m_isAppLimited   == rhs.m_isAppLimited
+          && lhs.m_interval       == rhs.m_interval
+          && lhs.m_delivered      == rhs.m_delivered
+          && lhs.m_priorDelivered == rhs.m_priorDelivered
+          && lhs.m_priorTime      == rhs.m_priorTime
+          && lhs.m_sendElapsed    == rhs.m_sendElapsed
+          && lhs.m_ackElapsed     == rhs.m_ackElapsed
+          );
+}
+
+bool
+operator== (TcpRateLinux::TcpRateConnection const & lhs,
+            TcpRateLinux::TcpRateConnection const & rhs)
+{
+  return (lhs.m_delivered       == rhs.m_delivered
+          && lhs.m_deliveredTime   == rhs.m_deliveredTime
+          && lhs.m_firstSentTime   == rhs.m_firstSentTime
+          && lhs.m_appLimited      == rhs.m_appLimited
+          );
+}
+
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-rate-ops.h ns-3.31/src/internet/model/tcp-rate-ops.h
--- ns-3.30.1/src/internet/model/tcp-rate-ops.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/internet/model/tcp-rate-ops.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,268 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+#ifndef TCP_RATE_OPS_H
+#define TCP_RATE_OPS_H
+
+#include "ns3/object.h"
+#include "ns3/tcp-tx-item.h"
+#include "ns3/traced-callback.h"
+#include "ns3/data-rate.h"
+#include "ns3/traced-value.h"
+
+namespace ns3 {
+
+/**
+ * \brief Interface for all operations that involve a Rate monitoring for TCP.
+ *
+ * The interface is meant to take information to generate rate information
+ * valid for congestion avoidance algorithm such as BBR.
+ *
+ * Please take a look to the TcpRateLinux class for an example.
+ */
+class TcpRateOps : public Object
+{
+public:
+  struct TcpRateSample;
+  struct TcpRateConnection;
+
+  /**
+   * Get the type ID.
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  /**
+   * \brief Put the rate information inside the sent skb
+   *
+   * Snapshot the current delivery information in the skb, to generate
+   * a rate sample later when the skb is (s)acked in SkbDelivered ().
+   *
+   * \param skb The SKB sent
+   * \param isStartOfTransmission true if this is a start of transmission
+   * (i.e., in_flight == 0)
+   */
+  virtual void SkbSent (TcpTxItem *skb, bool isStartOfTransmission) = 0;
+
+  /**
+   * \brief Update the Rate information after an item is received
+   *
+   * When an skb is sacked or acked, we fill in the rate sample with the (prior)
+   * delivery information when the skb was last transmitted.
+   *
+   * If an ACK (s)acks multiple skbs (e.g., stretched-acks), this function is
+   * called multiple times. We favor the information from the most recently
+   * sent skb, i.e., the skb with the highest prior_delivered count.
+   *
+   * \param skb The SKB delivered ((s)ACKed)
+   */
+  virtual void SkbDelivered (TcpTxItem * skb) = 0;
+
+  /**
+   * \brief If a gap is detected between sends, it means we are app-limited.
+   * \return TODO What the Linux kernel is setting in tp->app_limited?
+   * https://elixir.bootlin.com/linux/latest/source/net/ipv4/tcp_rate.c#L177
+   *
+   * \param cWnd Congestion Window
+   * \param in_flight In Flight size (in bytes)
+   * \param segmentSize Segment size
+   * \param tailSeq Tail Sequence
+   * \param nextTx NextTx
+   * \param lostOut Number of lost bytes
+   * \param retransOut Number of retransmitted bytes
+   */
+  virtual void CalculateAppLimited (uint32_t cWnd, uint32_t in_flight,
+                                    uint32_t segmentSize, const SequenceNumber32 &tailSeq,
+                                    const SequenceNumber32 &nextTx, const uint32_t lostOut,
+                                    const uint32_t retransOut) = 0;
+
+  /**
+   *
+   * \brief Generate a TcpRateSample to feed a congestion avoidance algorithm.
+   *
+   * This function will be called after an ACK (or a SACK) is received. The
+   * (S)ACK carries some implicit information, such as how many segments have been
+   * lost or delivered. These values will be this function input.
+   *
+   * \param delivered number of delivered segments (e.g., receiving a cumulative
+   * ACK means having more than 1 segment delivered) relative to the most recent
+   * (S)ACK received
+   * \param lost number of segments that we detected as lost after the reception
+   * of the most recent (S)ACK
+   * \param is_sack_reneg Is SACK reneged?
+   * \param minRtt Minimum RTT so far
+   * \return The TcpRateSample that will be used for CA
+   */
+  virtual const TcpRateSample & GenerateSample (uint32_t delivered, uint32_t lost,
+                                                bool is_sack_reneg, uint32_t priorInFlight,
+                                                const Time &minRtt) = 0;
+
+  /**
+   * \return The information about the rate connection
+   *
+   */
+  virtual const TcpRateConnection & GetConnectionRate () = 0;
+
+  /**
+   * \brief Rate Sample structure
+   *
+   * A rate sample measures the number of (original/retransmitted) data
+   * packets delivered "delivered" over an interval of time "interval_us".
+   * The tcp_rate code fills in the rate sample, and congestion
+   * control modules that define a cong_control function to run at the end
+   * of ACK processing can optionally chose to consult this sample when
+   * setting cwnd and pacing rate.
+   * A sample is invalid if "delivered" or "interval_us" is negative.
+   */
+  struct TcpRateSample
+  {
+    DataRate      m_deliveryRate   {DataRate ("0bps")};//!< The delivery rate sample
+    bool          m_isAppLimited   {false};            //!< Indicates whether the rate sample is application-limited
+    Time          m_interval       {Seconds (0.0)};    //!< The length of the sampling interval
+    int32_t       m_delivered      {0};                //!< The amount of data marked as delivered over the sampling interval
+    uint32_t      m_priorDelivered {0};                //!< The delivered count of the most recent packet delivered
+    Time          m_priorTime      {Seconds (0.0)};    //!< The delivered time of the most recent packet delivered
+    Time          m_sendElapsed    {Seconds (0.0)};    //!< Send time interval calculated from the most recent packet delivered
+    Time          m_ackElapsed     {Seconds (0.0)};    //!< ACK time interval calculated from the most recent packet delivered
+    uint32_t      m_bytesLoss      {0};                //!< The amount of data marked as lost from the most recent ack received
+    uint32_t      m_priorInFlight  {0};                //!< The value if bytes in flight prior to last received ack
+    uint32_t      m_ackedSacked    {0};                //!< The amount of data acked and sacked in the last received ack
+    /**
+     * \brief Is the sample valid?
+     * \return true if the sample is valid, false otherwise.
+     */
+    bool IsValid () const
+    {
+      return (m_priorTime != Seconds (0.0) || m_interval != Seconds (0.0));
+    }
+  };
+
+  /**
+   * \brief Information about the connection rate
+   *
+   * In this struct, the values are for the entire connection, and not just
+   * for an interval of time
+   */
+  struct TcpRateConnection
+  {
+    uint64_t  m_delivered       {0};           //!< The total amount of data in bytes delivered so far
+    Time      m_deliveredTime   {Seconds (0)}; //!< Simulator time when m_delivered was last updated
+    Time      m_firstSentTime   {Seconds (0)}; //!< The send time of the packet that was most recently marked as delivered
+    uint32_t  m_appLimited      {0};           //!< The index of the last transmitted packet marked as application-limited
+    uint32_t  m_txItemDelivered {0};           //!< The value of delivered when the acked item was sent
+    int32_t   m_rateDelivered   {0};           //!< The amount of data delivered considered to calculate delivery rate.
+    Time      m_rateInterval    {Seconds (0)}; //!< The value of interval considered to calculate delivery rate.
+    bool      m_rateAppLimited  {false};       //!< Was sample was taken when data is app limited?
+  };
+};
+
+/**
+ * \brief Linux management and generation of Rate information for TCP
+ *
+ * This class is inspired by what Linux is performing in tcp_rate.c
+ */
+class TcpRateLinux : public TcpRateOps
+{
+public:
+  /**
+   * Get the type ID.
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  virtual ~TcpRateLinux () override
+  {
+  }
+
+  virtual void SkbSent (TcpTxItem *skb, bool isStartOfTransmission) override;
+  virtual void SkbDelivered (TcpTxItem * skb) override;
+  virtual void CalculateAppLimited (uint32_t cWnd, uint32_t in_flight,
+                                    uint32_t segmentSize, const SequenceNumber32 &tailSeq,
+                                    const SequenceNumber32 &nextTx, const uint32_t lostOut,
+                                    const uint32_t retransOut) override;
+  virtual const TcpRateSample & GenerateSample (uint32_t delivered, uint32_t lost,
+                                                bool is_sack_reneg, uint32_t priorInFlight,
+                                                const Time &minRtt) override;
+  virtual const TcpRateConnection & GetConnectionRate () override
+  {
+    return m_rate;
+  }
+
+  /**
+   * TracedCallback signature for tcp rate update events.
+   *
+   * The callback will be fired each time the rate is updated.
+   *
+   * \param [in] rate The rate information.
+   */
+  typedef void (* TcpRateUpdated)(const TcpRateConnection &rate);
+
+  /**
+   * TracedCallback signature for tcp rate sample update events.
+   *
+   * The callback will be fired each time the rate sample is updated.
+   *
+   * \param [in] sample The rate sample that will be passed to congestion control
+   * algorithms.
+   */
+  typedef void (* TcpRateSampleUpdated)(const TcpRateSample &sample);
+
+private:
+  // Rate sample related variables
+  TcpRateConnection m_rate;         //!< Rate information
+  TcpRateSample     m_rateSample;   //!< Rate sample (continuosly updated)
+
+  TracedCallback<const TcpRateConnection &> m_rateTrace;       //!< Rate trace
+  TracedCallback<const TcpRateSample &>     m_rateSampleTrace; //!< Rate Sample trace
+};
+
+/**
+ * \brief Output operator.
+ * \param os The output stream.
+ * \param sample the TcpRateLinux::TcpRateSample to print.
+ * \returns The output stream.
+ */
+std::ostream & operator<< (std::ostream & os, TcpRateLinux::TcpRateSample const & sample);
+
+/**
+ * \brief Output operator.
+ * \param os The output stream.
+ * \param rate the TcpRateLinux::TcpRateConnection to print.
+ * \returns The output stream.
+ */
+std::ostream & operator<< (std::ostream & os, TcpRateLinux::TcpRateConnection const & rate);
+
+/**
+ * Comparison operator
+ * \param lhs left operand
+ * \param rhs right operand
+ * \return true if the operands are equal
+ */
+bool operator== (TcpRateLinux::TcpRateSample const & lhs, TcpRateLinux::TcpRateSample const & rhs);
+
+/**
+ * Comparison operator
+ * \param lhs left operand
+ * \param rhs right operand
+ * \return true if the operands are equal
+ */
+bool operator== (TcpRateLinux::TcpRateConnection const & lhs, TcpRateLinux::TcpRateConnection const & rhs);
+
+} //namespace ns3
+
+#endif /* TCP_RATE_OPS_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-recovery-ops.cc ns-3.31/src/internet/model/tcp-recovery-ops.cc
--- ns-3.30.1/src/internet/model/tcp-recovery-ops.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-recovery-ops.cc	2020-06-27 17:38:30.000000000 -0700
@@ -22,6 +22,7 @@
  */
 #include "tcp-recovery-ops.h"
 #include "tcp-socket-state.h"
+
 #include "ns3/log.h"
 
 namespace ns3 {
@@ -55,6 +56,11 @@
   NS_LOG_FUNCTION (this);
 }
 
+void
+TcpRecoveryOps::UpdateBytesSent (uint32_t bytesSent)
+{
+  NS_LOG_FUNCTION (this << bytesSent);
+}
 
 // Classic recovery
 
@@ -89,22 +95,20 @@
 
 void
 TcpClassicRecovery::EnterRecovery (Ptr<TcpSocketState> tcb, uint32_t dupAckCount,
-                                uint32_t unAckDataCount, uint32_t lastSackedBytes)
+                                   uint32_t unAckDataCount, uint32_t deliveredBytes)
 {
-  NS_LOG_FUNCTION (this << tcb << dupAckCount << unAckDataCount << lastSackedBytes);
+  NS_LOG_FUNCTION (this << tcb << dupAckCount << unAckDataCount);
   NS_UNUSED (unAckDataCount);
-  NS_UNUSED (lastSackedBytes);
+  NS_UNUSED (deliveredBytes);
   tcb->m_cWnd = tcb->m_ssThresh;
   tcb->m_cWndInfl = tcb->m_ssThresh + (dupAckCount * tcb->m_segmentSize);
 }
 
 void
-TcpClassicRecovery::DoRecovery (Ptr<TcpSocketState> tcb, uint32_t lastAckedBytes,
-                             uint32_t lastSackedBytes)
+TcpClassicRecovery::DoRecovery (Ptr<TcpSocketState> tcb, uint32_t deliveredBytes)
 {
-  NS_LOG_FUNCTION (this << tcb << lastAckedBytes << lastSackedBytes);
-  NS_UNUSED (lastAckedBytes);
-  NS_UNUSED (lastSackedBytes);
+  NS_LOG_FUNCTION (this << tcb << deliveredBytes);
+  NS_UNUSED (deliveredBytes);
   tcb->m_cWndInfl += tcb->m_segmentSize;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-recovery-ops.h ns-3.31/src/internet/model/tcp-recovery-ops.h
--- ns-3.30.1/src/internet/model/tcp-recovery-ops.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-recovery-ops.h	2020-06-27 17:38:30.000000000 -0700
@@ -20,7 +20,8 @@
  *         Mohit P. Tahiliani <tahiliani@nitk.edu.in>
  *
  */
-#pragma once
+#ifndef TCP_RECOVERY_OPS_H
+#define TCP_RECOVERY_OPS_H
 
 #include "ns3/object.h"
 
@@ -96,10 +97,10 @@
    * \param tcb internal congestion state
    * \param dupAckCount duplicate acknowldgement count
    * \param unAckDataCount total bytes of data unacknowledged
-   * \param lastSackedBytes bytes acknowledged via SACK in the last ACK
+   * \param deliveredBytes bytes (S)ACKed in the last (S)ACK
    */
   virtual void EnterRecovery (Ptr<TcpSocketState> tcb, uint32_t dupAckCount,
-                              uint32_t unAckDataCount, uint32_t lastSackedBytes) = 0;
+                              uint32_t unAckDataCount, uint32_t deliveredBytes) = 0;
 
   /**
    * \brief Performs recovery based on the recovery algorithm
@@ -108,15 +109,10 @@
    * is set to CA_RECOVERY. It performs the necessary cwnd changes
    * as per the recovery algorithm.
    *
-   * TODO: lastAckedBytes and lastSackedBytes should be one parameter
-   * that indicates how much data has been ACKed or SACKed.
-   *
    * \param tcb internal congestion state
-   * \param lastAckedBytes bytes acknowledged in the last ACK
-   * \param lastSackedBytes bytes acknowledged via SACK in the last ACK
+   * \param deliveredBytes bytes (S)ACKed in the last (S)ACK
    */
-  virtual void DoRecovery (Ptr<TcpSocketState> tcb, uint32_t lastAckedBytes,
-                           uint32_t lastSackedBytes) = 0;
+  virtual void DoRecovery (Ptr<TcpSocketState> tcb, uint32_t deliveredBytes) = 0;
 
   /**
    * \brief Performs cwnd adjustments at the end of recovery
@@ -136,10 +132,7 @@
    *
    * \param bytesSent bytes sent
    */
-  virtual void UpdateBytesSent (uint32_t bytesSent)
-  {
-    NS_UNUSED (bytesSent);
-  }
+  virtual void UpdateBytesSent (uint32_t bytesSent);
 
   /**
    * \brief Copy the recovery algorithm across socket
@@ -191,10 +184,9 @@
   virtual std::string GetName () const override;
 
   virtual void EnterRecovery (Ptr<TcpSocketState> tcb, uint32_t dupAckCount,
-                              uint32_t unAckDataCount, uint32_t lastSackedBytes) override;
+                              uint32_t unAckDataCount, uint32_t deliveredBytes) override;
 
-  virtual void DoRecovery (Ptr<TcpSocketState> tcb, uint32_t lastAckedBytes,
-                           uint32_t lastSackedBytes) override;
+  virtual void DoRecovery (Ptr<TcpSocketState> tcb, uint32_t deliveredBytes) override;
 
   virtual void ExitRecovery (Ptr<TcpSocketState> tcb) override;
 
@@ -202,3 +194,5 @@
 };
 
 } // namespace ns3
+
+#endif /* TCP_RECOVERY_OPS_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-scalable.cc ns-3.31/src/internet/model/tcp-scalable.cc
--- ns-3.30.1/src/internet/model/tcp-scalable.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-scalable.cc	2020-06-27 17:38:30.000000000 -0700
@@ -28,6 +28,8 @@
  */
 
 #include "tcp-scalable.h"
+#include "tcp-socket-state.h"
+
 #include "ns3/log.h"
 
 namespace ns3 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-scalable.h ns-3.31/src/internet/model/tcp-scalable.h
--- ns-3.30.1/src/internet/model/tcp-scalable.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-scalable.h	2020-06-27 17:38:30.000000000 -0700
@@ -30,11 +30,12 @@
 #ifndef TCPSCALABLE_H
 #define TCPSCALABLE_H
 
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-recovery-ops.h"
+#include "tcp-congestion-ops.h"
 
 namespace ns3 {
 
+class TcpSocketState;
+
 /**
  * \ingroup congestionOps
  *
